<template>
  <div>

    <div class="red mb-5 text-center">Note : * Wajib diisi</div>

    <b-alert
    :show="dismissCountDown"
    dismissible
    variant="danger"
    @dismissed="dismissCountDown=0"
    @dismiss-count-down="countDownChanged"
    >
    <p>Maaf terdapat gangguan, silahkan coba kembali</p>
    <b-progress
    variant="danger"
    :max="dismissSecs"
    :value="dismissCountDown"
    height="2px"
    ></b-progress>
  </b-alert>
  
  <form>

    <div class="row">
      <div class="form-group col-lg-12">
        <label for="">Nama Lengkap <span class="red">*</span>
        </label>
        <input type="text" name="nama" class="form-control" placeholder="Nama Lengkap"
        v-model="register.nama"
        v-validate="'required'"
        >
        <div class="text-danger">{{ veeErrors.first('nama') }}</div>
        <div class="help-block" v-if="errors">{{ errors['nama'] }}</div>
      </div>

      <div class="form-group col-lg-12">
        <label for="">Email </label>
        <span class="red">*</span>
        <input type="email" name="email" class="form-control" placeholder="Alamat Email" 
        v-model="register.email"
        v-validate="'required|email|email_exists'"
        >
        <div class="text-danger">{{ veeErrors.first('email') }}</div>
        <div class="help-block" v-if="errors">{{ errors['email'] }}</div>
      </div>
      <div class="form-group col-lg-12 ">
        <label for="">Password</label>
        <span class="red">*</span>
        <input type="password" name="password" class="form-control" placeholder="Password" 
        v-model="register.password"
        v-validate="'required|min:6'"
        ref="password"
        >
        <div class="text-danger">{{ veeErrors.first('password') }}</div>
        <div class="help-block" v-if="errors">{{ errors['password'] }}</div>
      </div>

      <div class="form-group col-lg-12">
        <label for="">Password Confirmation</label>
        <span class="red">*</span>
        <input type="password" name="password_confirmation" class="form-control" placeholder="Konfirmasi Password"
        v-model="register.password_confirmation"
        v-validate="'required|confirmed:password'"
        >
        <div class="text-danger">{{ veeErrors.first('password_confirmation') }}</div>
      </div>
    </div>

    <div class="row">
      <div class="form-group col">
        <!-- <a href="/" class="btn btn-danger text-3 font-weight-bold px-4 py-2">Batal</a> -->
        <input type="submit" value="Daftar" class="btn btn-success text-3 font-weight-bold px-4 py-2" @click.prevent="submitRegister">
      </div>
    </div>
  </form>

  <div>

    <!-- <b-button id="show-btn" @click="$bvModal.show('showModal')">Open Modal</b-button> -->
    <b-modal id="showModal" hide-footer>
    <!-- <template #modal-title>
      Using <code>$bvModal</code> Methods
    </template> -->
    <div class="d-block text-center">
      <h4>Loading, Please wait...</h4>
      <b-spinner variant="primary" label="Text Centered" style="width: 3rem; height: 3rem;"></b-spinner>
    </div>
    <!-- <b-button class="mt-3" block @click="$bvModal.hide('showModal')">Close Me</b-button> -->
  </b-modal>

</div> 

</div>
</template>

<script>
  import AxiosMixin from "./mixins/axiosMixins.js";



  export default {
    props: ["dataprop"],
    mixins: [AxiosMixin],
    name: 'GoogleMap',
    data() {
      return {
        url: "",
        type: "",
        register: {},
        dismissSecs: 5,
        dismissCountDown: 0,
        showDismissibleAlert: false,
        errors: null,

      }
    },

    mounted() {
    // this.geolocate();
  },

  created() {
    this.initial();
  },

  methods: {

    initial() {
      this.checkEmail()
    },
    checkEmail(){
      this.$validator.extend('email_exists', {
      getMessage: field => `The email is already in the system.`,
      validate: value => {
              // console.log(value)
              return axios.get('/checkemail/'+value).then(response => {
                  // console.log(response.data.valid)
                  return {
                        valid: response.data.valid // Your api could return a response containing a 'valid property'
                      }
                    }).catch(error=> { return { error: response.error.val } });
            }
          });
    },
    submitRegister() {
     this.$validator.validate().then(valid => {
      if (valid) {
        this.submit(this.register)
        // console.log(this.register)
      }
    });
   },
   submit(value){
    let formData = this.formData(this.register)
    let url = `/auditor/registrasi`

    axios.post(url,formData).then(res => {
      if (res.data.message === 'success'){
        let data = this.register
        let dataEmit = {
          action:'notif',
          data
        }
        this.$emit("data-register",dataEmit);
      }
      else{
        this.showAlert()
      }

    }).catch(err =>{
      this.errors = err.response.data.errors
    })

  },
  formData(obj){
    var formData = new FormData();
    for (var key in obj) {
      formData.append(key, obj[key]);
    }
    return formData;
  },
  countDownChanged(dismissCountDown) {
    this.dismissCountDown = dismissCountDown
  },
  showAlert() {
    this.dismissCountDown = this.dismissSecs
  },

  setPlace(place) {
    this.currentPlace = place;
  },
  addMarker() {
    if (this.currentPlace) {
      const marker = {
        lat: this.currentPlace.geometry.location.lat(),
        lng: this.currentPlace.geometry.location.lng(),
      };
      this.markers.push({ position: marker });
      this.places.push(this.currentPlace);
      this.center = marker;
      this.currentPlace = null;
      this.register.map = JSON.stringify(marker);
    }
  },
  geolocate: function() {
    navigator.geolocation.getCurrentPosition(position => {
      this.center = {
        lat: position.coords.latitude,
        lng: position.coords.longitude,
      };
    });
  },
  updateCoordinates(location) {
    const marker = {
      lat: location.latLng.lat(),
      lng: location.latLng.lng(),
    };
    this.center = marker;
    this.currentPlace = null;
    this.register.map = JSON.stringify(marker);
  },

},
};
</script>
<style src='vue-multiselect/dist/vue-multiselect.min.css'></style>
<style>

  .multiselect__input{
    width:0px!important;
  }

  .modal-header{
    display: none;
  }

  .modal-dialog {
    max-width: 250px;
    margin: 1.75rem auto;
  }

  .pac-target-input{
    width: 50%;
  }

</style>